Package org.eclipse.emf.cdo.spi.common.revision

## Class AbstractCDORevision

- java.lang.Object
- - org.eclipse.emf.cdo.spi.common.revision.AbstractCDORevision

- All Implemented Interfaces:
    `CDOBranchPoint`, `CDOBranchProvider`, `CDOBranchVersion`, `CDOIdentifiable`, `CDOIDAndVersion`, `CDORevisable`, `CDORevision`, `CDORevisionData`, `CDORevisionKey`, `CDOTimeProvider`, `CDOVersionProvider`, `CDOBranchAdjustable`, `CDOReferenceAdjustable`, `InternalCDORevision`
  Direct Known Subclasses:
    `BaseCDORevision`, `StubCDORevision`

      public abstract class AbstractCDORevision
      extends java.lang.Object
      implements InternalCDORevision

  If the meaning of this type isn't clear, there really should be more of a description here...
  Since:
    2.0
  Author:
    Eike Stepper

- - ### Field Summary

    - ### Fields inherited from interface org.eclipse.emf.cdo.common.branch.CDOBranchPoint

      `INVALID_DATE, UNSPECIFIED_DATE`

    - ### Fields inherited from interface org.eclipse.emf.cdo.common.branch.CDOBranchVersion

      `UNSPECIFIED_VERSION`

    - ### Fields inherited from interface org.eclipse.emf.cdo.common.revision.CDORevision

      `DEPTH_INFINITE, DEPTH_NONE, FIRST_VERSION, MAIN_BRANCH_ID, PERMISSION_PROVIDER, UNCHUNKED`

    - ### Fields inherited from interface org.eclipse.emf.cdo.common.revision.CDORevisionData

      `NIL`

    - ### Fields inherited from interface org.eclipse.emf.cdo.spi.common.revision.InternalCDORevision

      `DO_NOT_CREATE_LIST`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `AbstractCDORevision​(InternalCDOClassInfo classInfo)` |
    `protected` | `AbstractCDORevision​(org.eclipse.emf.ecore.EClass eClass)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `accept​(CDORevisionValueVisitor visitor)` |
    `void` | `accept​(CDORevisionValueVisitor visitor, java.util.function.Predicate<org.eclipse.emf.ecore.EStructuralFeature> filter)` |
    `void` | `accept​(CDORevisionValueVisitor visitor, org.eclipse.net4j.util.Predicate<org.eclipse.emf.ecore.EStructuralFeature> filter)` | Deprecated.
    `void` | `adjustForCommit​(CDOBranch branch, long timeStamp)` |
    `CDORevisionData` | `data()` |
    `boolean` | `equals​(java.lang.Object obj)` |
    `protected org.eclipse.emf.ecore.EStructuralFeature[]` | `getAllPersistentFeatures()` |
    `InternalCDOClassInfo` | `getClassInfo()` |
    `org.eclipse.emf.ecore.EClass` | `getEClass()` |
    `protected int` | `getFeatureIndex​(org.eclipse.emf.ecore.EStructuralFeature feature)` |
    `CDOList` | `getList​(org.eclipse.emf.ecore.EStructuralFeature feature)` | Deprecated.
    `CDOList` | `getList​(org.eclipse.emf.ecore.EStructuralFeature feature, int initialCapacity)` | Deprecated.
    `InternalCDORevision` | `getProperRevision()` |
    `InternalCDORevision` | `getRevisionForID​(CDOID id)` |
    `int` | `hashCode()` |
    `protected void` | `initClassInfo​(org.eclipse.emf.ecore.EClass eClass)` |
    `boolean` | `isHistorical()` | Returns `true` exactly if `CDOBranchPoint.getTimeStamp()` does not return `CDOBranchPoint.UNSPECIFIED_DATE`, `false` otherwise.
    `boolean` | `isReadable()` |
    `boolean` | `isResource()` |
    `boolean` | `isResourceFolder()` |
    `boolean` | `isResourceNode()` |
    `boolean` | `isValid​(long timeStamp)` |
    `boolean` | `isValid​(CDOBranchPoint branchPoint)` |
    `boolean` | `isWritable()` |
    `CDORevision` | `revision()` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.emf.cdo.spi.common.branch.CDOBranchAdjustable

      `adjustBranches`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.branch.CDOBranchPoint

      `getTimeStamp`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.branch.CDOBranchVersion

      `getVersion`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.revision.CDOIDAndVersion

      `getVersion`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.id.CDOIdentifiable

      `getID`

    - ### Methods inherited from interface org.eclipse.emf.cdo.spi.common.revision.CDOReferenceAdjustable

      `adjustReferences`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.revision.CDORevisable

      `getRevised`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.revision.CDORevision

      `getPermission, merge`

    - ### Methods inherited from interface org.eclipse.emf.cdo.common.revision.CDORevisionData

      `contains, get, getContainerID, getContainingFeatureID, getResourceID, hashCode, indexOf, isEmpty, lastIndexOf, size, toArray, toArray`

    - ### Methods inherited from interface org.eclipse.emf.cdo.spi.common.revision.InternalCDORevision

      `add, bypassPermissionChecks, clear, clearValues, compare, convertEObjects, copy, freeze, getBranch, getListOrNull, getOrCreateList, getOrCreateList, getResourceNodeName, getValue, isFrozen, isListPreserving, isUnchunked, move, read, readValues, remove, set, setBranchPoint, setContainerID, setContainingFeatureID, setID, setList, setListPreserving, setPermission, setResourceID, setRevised, setUnchunked, setValue, setVersion, unset, write, write, writeValues`

- - ### Constructor Detail

    - #### AbstractCDORevision

          protected AbstractCDORevision​(org.eclipse.emf.ecore.EClass eClass)

      Since:
        3.0

    - #### AbstractCDORevision

          protected AbstractCDORevision​(InternalCDOClassInfo classInfo)

      Since:
        4.2

  - ### Method Detail

    - #### getClassInfo

          public final InternalCDOClassInfo getClassInfo()

      Specified by:
        `getClassInfo` in interface `CDORevision`
      Specified by:
        `getClassInfo` in interface `InternalCDORevision`
      Since:
        4.2

    - #### getEClass

          public final org.eclipse.emf.ecore.EClass getEClass()

      Specified by:
        `getEClass` in interface `CDORevision`

    - #### getRevisionForID

          public InternalCDORevision getRevisionForID​(CDOID id)

      Specified by:
        `getRevisionForID` in interface `InternalCDORevision`
      Since:
        4.2

    - #### getProperRevision

          public InternalCDORevision getProperRevision()

      Specified by:
        `getProperRevision` in interface `InternalCDORevision`
      Since:
        4.2

    - #### isResourceNode

          public boolean isResourceNode()

      Specified by:
        `isResourceNode` in interface `CDORevision`

    - #### isResourceFolder

          public boolean isResourceFolder()

      Specified by:
        `isResourceFolder` in interface `CDORevision`

    - #### isResource

          public boolean isResource()

      Specified by:
        `isResource` in interface `CDORevision`

    - #### data

          public CDORevisionData data()

      Specified by:
        `data` in interface `CDORevision`

    - #### revision

          public CDORevision revision()

      Specified by:
        `revision` in interface `CDORevisionData`

    - #### isHistorical

          public boolean isHistorical()

      Description copied from interface: `CDORevision`
      Returns `true` exactly if `CDOBranchPoint.getTimeStamp()` does not return `CDOBranchPoint.UNSPECIFIED_DATE`, `false` otherwise.
      Specified by:
        `isHistorical` in interface `CDORevision`
      Since:
        3.0

    - #### isValid

          public boolean isValid​(long timeStamp)

      Specified by:
        `isValid` in interface `CDORevision`

    - #### isValid

          public boolean isValid​(CDOBranchPoint branchPoint)

      Specified by:
        `isValid` in interface `CDORevision`
      Since:
        4.0

    - #### isReadable

          public boolean isReadable()

      Specified by:
        `isReadable` in interface `CDORevision`
      Since:
        4.1

    - #### isWritable

          public boolean isWritable()

      Specified by:
        `isWritable` in interface `CDORevision`
      Since:
        4.1

    - #### accept

          public void accept​(CDORevisionValueVisitor visitor)

      Specified by:
        `accept` in interface `CDORevisionData`
      Since:
        4.2

    - #### accept

          @Deprecated
          public void accept​(CDORevisionValueVisitor visitor,
                             org.eclipse.net4j.util.Predicate<org.eclipse.emf.ecore.EStructuralFeature> filter)

      Deprecated.
      Specified by:
        `accept` in interface `CDORevisionData`
      Since:
        4.2

    - #### accept

          public void accept​(CDORevisionValueVisitor visitor,
                             java.util.function.Predicate<org.eclipse.emf.ecore.EStructuralFeature> filter)

      Specified by:
        `accept` in interface `CDORevisionData`
      Since:
        4.9

    - #### adjustForCommit

          public void adjustForCommit​(CDOBranch branch,
                                      long timeStamp)

      Specified by:
        `adjustForCommit` in interface `InternalCDORevision`
      Since:
        3.0

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getList

          @Deprecated
          public CDOList getList​(org.eclipse.emf.ecore.EStructuralFeature feature)

      Deprecated.
      Specified by:
        `getList` in interface `InternalCDORevision`

    - #### getList

          @Deprecated
          public CDOList getList​(org.eclipse.emf.ecore.EStructuralFeature feature,
                                 int initialCapacity)

      Deprecated.
      Specified by:
        `getList` in interface `InternalCDORevision`

    - #### initClassInfo

          protected void initClassInfo​(org.eclipse.emf.ecore.EClass eClass)

      Since:
        4.2

    - #### getAllPersistentFeatures

          protected org.eclipse.emf.ecore.EStructuralFeature[] getAllPersistentFeatures()

      Since:
        3.0

    - #### getFeatureIndex

          protected int getFeatureIndex​(org.eclipse.emf.ecore.EStructuralFeature feature)

      Since:
        3.0